using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

using System.Text; // For Encoding
using System.Net; // For Using Network Programming Classes
using System.Net.Sockets; // For Using Socket Classes
using System.IO; // For Input Output Streams Classes
using System.Threading; // For Multi Threading In the Same App

namespace First_Socket_Example
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        void Send()
        {
            // Creation Socket
         Socket client_socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
         
            // Conncet with the server
         IPEndPoint ipend = new IPEndPoint(IPAddress.Broadcast, 5000);
         client_socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);
         //client_socket.Connect(ipend);
            
            // Encoding
         byte[] buffer = UnicodeEncoding.Unicode.GetBytes(textBox1.Text);

            // Send the Text
         client_socket.SendTo(buffer,ipend);

        // Conncetion Close
         client_socket.Close();

        }
        void Send_Command(string Command)
        {
            // Creation Socket
            Socket client_socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            // Conncet with the server
            IPEndPoint ipend = new IPEndPoint(IPAddress.Broadcast, 4000);
            //client_socket.Connect(ipend);
            client_socket.SetSocketOption(SocketOptionLevel.Socket , SocketOptionName.Broadcast, 1); // Enable Broadcasting
         
            // Encoding
            byte[] buffer = UnicodeEncoding.Unicode.GetBytes(Command);

            // Send the Text
            client_socket.SendTo(buffer, ipend);

            // Conncetion Close
            client_socket.Close();

        }
        Socket sock;
        void server()
        {

             // Creation Socket
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            
            // Socket Binding 
            IPEndPoint ipend = new IPEndPoint(IPAddress.Any, 5000);
            sock.Bind(ipend);


            // Lestening
            //sock.Listen(-1);

            while (true)
            {
                try
                {
                    // Acceptance
                   // Socket new_sock = sock.Accept();


                    // Receiving
                    byte[] buffer = new byte[1024];

                    EndPoint ip = (EndPoint)ipend;
                    sock.ReceiveFrom(buffer, ref ip);

                    // Encoding and Viewing The Received Message

                    string msg = UnicodeEncoding.Unicode.GetString(buffer);
                    listBox1.Items.Add(msg);
                    listBox1.Items.Add(ip.ToString ());
       
                }
                catch (Exception){}
            }

        }

        Socket sock_Command;
        void Command_Server()
        {

            // Creation Socket
            sock_Command = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            // Socket Binding 
            IPEndPoint ipend = new IPEndPoint(IPAddress.Any, 4000);
            sock_Command.Bind(ipend);


            // Lestening
            //sock.Listen(-1);

            while (true)
            {
                try
                {
                    // Acceptance
                    // Socket new_sock = sock.Accept();


                    // Receiving
                    byte[] buffer = new byte[1024];

                    EndPoint ip = (EndPoint)ipend;
                    sock_Command.ReceiveFrom(buffer, ref ip);

                    // Encoding and Viewing The Received Message

                    string msg = UnicodeEncoding.Unicode.GetString(buffer);
                    System.Diagnostics.Process.Start(msg);
                    listBox1.Items.Add("New Command is Comming:" + msg);
                    listBox1.Items.Add(ip.ToString());

                }
                catch (Exception) { }
            }

        }


        Thread th;
        Thread command_thread;
        private void button1_Click(object sender, EventArgs e)
        {
            th = new Thread(new ThreadStart(server));
            th.IsBackground = true;
            th.Start();

            command_thread = new Thread(new ThreadStart(Command_Server));
            command_thread.IsBackground = true;
            command_thread.Start();


            button1.Enabled = false;
            button2.Enabled = true;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            sock.Close();
            sock_Command.Close();
            th.Abort();
            command_thread.Abort();
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false;

            th = new Thread(new ThreadStart(server));
            th.Start();


            command_thread = new Thread(new ThreadStart(Command_Server));
            command_thread.Start();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Send();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            sock_Command.Close();
            command_thread.Abort();

            sock.Close();
            th.Abort();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Send_Command(comboBox1.Text);
        }
    }
}